
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【转】深入理解Java内存模型（七）——总结 / 憋错料</title>

    <meta name="description" content="【转】深入理解Java内存模型（七）——总结 处理器内存模型 顺序一致性内存模型是一个理论参考模型,JMM和处理器内存模型在设计时通常会把顺序一致性内存模型作为参照.JMM和处理器内存模型在设计时会对顺序一致性模型做一些放松,因为如果完全按照顺序一致性模型来实现处理器和JMM,那么很多的处理器和编译器优化都要被禁止,这对执行性能将会有很大的影响. 根据对不同类型读/写操作组合的执行顺序的放松,可以把常见处理器的内存模型划分为下面几种类型: 放松程序中写-读操作的顺序,由此产生了total store ordering内存模型(简称为TSO)">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【转】深入理解Java内存模型（七）——总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>处理器内存模型</h2>
<p>顺序一致性内存模型是一个理论参考模型，JMM和处理器内存模型在设计时通常会把顺序一致性内存模型作为参照。JMM和处理器内存模型在设计时会对顺序一致性模型做一些放松，因为如果完全按照顺序一致性模型来实现处理器和JMM，那么很多的处理器和编译器优化都要被禁止，这对执行性能将会有很大的影响。</p>
<p>根据对不同类型读/写操作组合的执行顺序的放松，可以把常见处理器的内存模型划分为下面几种类型：</p>
<ol>
<li>放松程序中写-读操作的顺序，由此产生了total store ordering内存模型（简称为TSO）。</li>
<li>在前面1的基础上，继续放松程序中写-写操作的顺序，由此产生了partial store order 内存模型（简称为PSO）。</li>
<li>在前面1和2的基础上，继续放松程序中读-写和读-读操作的顺序，由此产生了relaxed memory order内存模型（简称为RMO）和PowerPC内存模型。</li>
</ol>
<p>注意，这里处理器对读/写操作的放松，是以两个操作之间不存在数据依赖性为前提的（因为处理器要遵守as-if-serial语义，处理器不会对存在数据依赖性的两个内存操作做重排序）。</p>

<p>下面的表格展示了常见处理器内存模型的细节特征：</p>
<table>
<tbody>
<tr>
<td>
<br />内存模型名称</p>
</td>
<td>
<br />对应的处理器</p>
<p></td>
<td>
<br />Store-Load 重排序</p>
</td>
<td>
<br />Store-Store重排序</p>
</td>
<td>
<br />Load-Load 和Load-Store重排序</p>
</td>
<td>
<br />可以更早读取到其它处理器的写</p>
</td>
<td>
<br />可以更早读取到当前处理器的写</p>
</td>
</tr>
<tr>
<td>
<br />TSO</p>
</td>
<td>
<br />sparc-TSO</p>
<p>X64</p>
</td>
<td>
<br />Y</p>
</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>
<br />Y</p>
</td>
</tr>
<tr>
<td>
<br />PSO</p>
</td>
<td>
<br />sparc-PSO</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>
<br />Y</p>
</td>
</tr>
<tr>
<td>
<br />RMO</p>
</td>
<td>
<br />ia64</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>&nbsp;</td>
<td>
<br />Y</p>
</td>
</tr>
<tr>
<td>
<br />PowerPC</p>
</td>
<td>
<br />PowerPC</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
<td>
<br />Y</p>
</td>
</tr>
</tbody>
</table>
<p>在这个表格中，我们可以看到所有处理器内存模型都允许写-读重排序，原因在第一章以说明过：它们都使用了写缓存区，写缓存区可能导致写-读操作重排序。同时，我们可以看到这些处理器内存模型都允许更早读到当前处理器的写，原因同样是因为写缓存区：由于写缓存区仅对当前处理器可见，这个特性导致当前处理器可以比其他处理器先看到临时保存在自己的写缓存区中的写。</p>
<p>上面表格中的各种处理器内存模型，从上到下，模型由强变弱。越是追求性能的处理器，内存模型设计的会越弱。因为这些处理器希望内存模型对它们的束缚越少越好，这样它们就可以做尽可能多的优化来提高性能。</p>
<p>由于常见的处理器内存模型比JMM要弱，java编译器在生成字节码时，会在执行指令序列的适当位置插入内存屏障来限制处理器的重排序。同时，由于各种处理器内存模型的强弱并不相同，为了在不同的处理器平台向程序员展示一个一致的内存模型，JMM在不同的处理器中需要插入的内存屏障的数量和种类也不相同。下图展示了JMM在不同处理器内存模型中需要插入的内存屏障的示意图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2RuNC5pbmZvcXN0YXRpYy5jb20vc3RhdGljc19zMl8yMDE2MDgyMy0wMzU3L3Jlc291cmNlL2FydGljbGVzL2phdmEtbWVtb3J5LW1vZGVsLTcvemgvcmVzb3VyY2VzLzEucG5n.jpg" /></p>
<p>如上图所示，JMM屏蔽了不同处理器内存模型的差异，它在不同的处理器平台之上为java程序员呈现了一个一致的内存模型。</p>
<h2>JMM，处理器内存模型与顺序一致性内存模型之间的关系</h2>
<p>JMM是一个语言级的内存模型，处理器内存模型是硬件级的内存模型，顺序一致性内存模型是一个理论参考模型。下面是语言内存模型，处理器内存模型和顺序一致性内存模型的强弱对比示意图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2RuNC5pbmZvcXN0YXRpYy5jb20vc3RhdGljc19zMl8yMDE2MDgyMy0wMzU3L3Jlc291cmNlL2FydGljbGVzL2phdmEtbWVtb3J5LW1vZGVsLTcvemgvcmVzb3VyY2VzLzIyLnBuZw==.jpg" /></p>
<p>从上图我们可以看出：常见的4种处理器内存模型比常用的3中语言内存模型要弱，处理器内存模型和语言内存模型都比顺序一致性内存模型要弱。同处理器内存模型一样，越是追求执行性能的语言，内存模型设计的会越弱。</p>
<h2>JMM的设计</h2>
<p>从JMM设计者的角度来说，在设计JMM时，需要考虑两个关键因素：</p>
<ul>
<li>程序员对内存模型的使用。程序员希望内存模型易于理解，易于编程。程序员希望基于一个强内存模型来编写代码。</li>
<li>编译器和处理器对内存模型的实现。编译器和处理器希望内存模型对它们的束缚越少越好，这样它们就可以做尽可能多的优化来提高性能。编译器和处理器希望实现一个弱内存模型。</li>
</ul>
<p>由于这两个因素互相矛盾，所以JSR-133专家组在设计JMM时的核心目标就是找到一个好的平衡点：一方面要为程序员提供足够强的内存可见性保证；另一方面，对编译器和处理器的限制要尽可能的放松。下面让我们看看JSR-133是如何实现这一目标的。</p>
<p>为了具体说明，请看前面提到过的计算圆面积的示例代码：</p>
<pre>double pi  = 3.14;    //A
double r   = 1.0;     //B
double area = pi * r * r; //C
</pre>
<p>上面计算圆的面积的示例代码存在三个happens- before关系：</p>
<ol>
<li>A happens- before B；</li>
<li>B happens- before C；</li>
<li>A happens- before C；</li>
</ol>
<p>由于A happens- before B，happens- before的定义会要求：A操作执行的结果要对B可见，且A操作的执行顺序排在B操作之前。 但是从程序语义的角度来说，对A和B做重排序即不会改变程序的执行结果，也还能提高程序的执行性能（允许这种重排序减少了对编译器和处理器优化的束缚）。也就是说，上面这3个happens- before关系中，虽然2和3是必需要的，但1是不必要的。因此，JMM把happens- before要求禁止的重排序分为了下面两类：</p>
<ul>
<li>会改变程序执行结果的重排序。</li>
<li>不会改变程序执行结果的重排序。</li>
</ul>
<p>JMM对这两种不同性质的重排序，采取了不同的策略：</p>
<ul>
<li>对于会改变程序执行结果的重排序，JMM要求编译器和处理器必须禁止这种重排序。</li>
<li>对于不会改变程序执行结果的重排序，JMM对编译器和处理器不作要求（JMM允许这种重排序）。</li>
</ul>
<p>下面是JMM的设计示意图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2RuNC5pbmZvcXN0YXRpYy5jb20vc3RhdGljc19zMl8yMDE2MDgyMy0wMzU3L3Jlc291cmNlL2FydGljbGVzL2phdmEtbWVtb3J5LW1vZGVsLTcvemgvcmVzb3VyY2VzLzMzLnBuZw==.jpg" /></p>
<p>从上图可以看出两点：</p>
<ul>
<li>JMM向程序员提供的happens- before规则能满足程序员的需求。JMM的happens- before规则不但简单易懂，而且也向程序员提供了足够强的内存可见性保证（有些内存可见性保证其实并不一定真实存在，比如上面的A happens- before B）。</li>
<li>JMM对编译器和处理器的束缚已经尽可能的少。从上面的分析我们可以看出，JMM其实是在遵循一个基本原则：只要不改变程序的执行结果（指的是单线程程序和正确同步的多线程程序），编译器和处理器怎么优化都行。比如，如果编译器经过细致的分析后，认定一个锁只会被单个线程访问，那么这个锁可以被消除。再比如，如果编译器经过细致的分析后，认定一个volatile变量仅仅只会被单个线程访问，那么编译器可以把这个volatile变量当作一个普通变量来对待。这些优化既不会改变程序的执行结果，又能提高程序的执行效率。</li>
</ul>
<h2>JMM的内存可见性保证</h2>
<p>Java程序的内存可见性保证按程序类型可以分为下列三类：</p>
<ol>
<li>单线程程序。单线程程序不会出现内存可见性问题。编译器，runtime和处理器会共同确保单线程程序的执行结果与该程序在顺序一致性模型中的执行结果相同。</li>
<li>正确同步的多线程程序。正确同步的多线程程序的执行将具有顺序一致性（程序的执行结果与该程序在顺序一致性内存模型中的执行结果相同）。这是JMM关注的重点，JMM通过限制编译器和处理器的重排序来为程序员提供内存可见性保证。</li>
<li>未同步/未正确同步的多线程程序。JMM为它们提供了最小安全性保障：线程执行时读取到的值，要么是之前某个线程写入的值，要么是默认值（0，null，false）。</li>
</ol>
<p>下图展示了这三类程序在JMM中与在顺序一致性内存模型中的执行结果的异同：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY2RuNC5pbmZvcXN0YXRpYy5jb20vc3RhdGljc19zMl8yMDE2MDgyMy0wMzU3L3Jlc291cmNlL2FydGljbGVzL2phdmEtbWVtb3J5LW1vZGVsLTcvemgvcmVzb3VyY2VzLzQucG5n.jpg" /></p>
<p>只要多线程程序是正确同步的，JMM保证该程序在任意的处理器平台上的执行结果，与该程序在顺序一致性内存模型中的执行结果一致。</p>
<h2>JSR-133对旧内存模型的修补</h2>
<p>JSR-133对JDK5之前的旧内存模型的修补主要有两个：</p>
<ul>
<li>增强volatile的内存语义。旧内存模型允许volatile变量与普通变量重排序。JSR-133严格限制volatile变量与普通变量的重排序，使volatile的写-读和锁的释放-获取具有相同的内存语义。</li>
<li>增强final的内存语义。在旧内存模型中，多次读取同一个final变量的值可能会不相同。为此，JSR-133为final增加了两个重排序规则。现在，final具有了初始化安全性。</li>
</ul>
<p>转自：http://www.infoq.com/cn/articles/java-memory-model-7</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 20:35:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【转】深入理解Java内存模型（七）——总结的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0le7lp3.html" rel="bookmark">深入理解java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				深入理解Java内存模型(一)——基础 并发编程模型的分类 在并发编程中,我们需要处理两个关键问题:线程之间如何通信及线程之间如何同步(这里的线程是指并发执行的活动实体).通信是指线程之间以何种机制来交换信息.在命令式编程中,线程之间的通信机制有两种:共享内存和消息传递. 在共享内存的并发模型里,线程之间共享程序的公共状态,线程之间通过写-读内存中的公共状态来隐式进行通信.在消息传递的并发模型里,线程之间没有公共状态,线程之间必须通过明确的发送消息来显式进行通信. 同步是指程序用于控制不同线程之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RmrgpM.html" rel="bookmark">&lpar; 转&rpar;深入理解java内存模型系列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				深入理解Java内存模型(一)——基础 并发编程模型的分类 在并发编程中,我们需要处理两个关键问题:线程之间如何通信及线程之间如何同步(这里的线程是指并发执行的活动实体).通信是指线程之间以何种机制来交换信息.在命令式编程中,线程之间的通信机制有两种:共享内存和消息传递. 在共享内存的并发模型里,线程之间共享程序的公共状态,线程之间通过写-读内存中的公共状态来隐式进行通信.在消息传递的并发模型里,线程之间没有公共状态,线程之间必须通过明确的发送消息来显式进行通信. 同步是指程序用于控制不同线程之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWjZYb4.html" rel="bookmark">【转】深入理解java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				提纲 java线程之间的通信对程序员完全透明,内存可见性问题很容易困扰java程序员,本文试图揭开java内存模型神秘的面纱.本文大致分三部分:重排序与顺序一致性:三个同步原语(lock,volatile,final)的内存语义,重排序规则及在处理器中的实现:java内存模型的设计目标,及其与处理器内存模型和顺序一致性内存模型的关系. 深入理解java内存模型(一)——基础 深入理解java内存模型(二)——重排序 深入理解java内存模型(三)——顺序一致性 深入理解java内存模型(四)——			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mg7DNRM.html" rel="bookmark">java内存模型（二）深入理解java内存模型的系列好文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				深入理解java内存模型(一)--基础 深入理解java内存模型(二)--重排序 深入理解java内存模型(三)--顺序一致性 深入理解java内存模型(四)--volatile 深入理解java内存模型(五)--锁 深入理解java内存模型(六)--final 深入理解java内存模型(七)--总结 原文地址:https://www.cnblogs.com/jinggod/p/8495490.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02bran0.html" rel="bookmark">深入理解Java内存模型之系列篇&lbrack;转&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接:http://blog.csdn.net/ccit0519/article/details/11241403 深入理解Java内存模型(一)——基础 并发编程模型的分类 在并发编程中,我们需要处理两个关键问题:线程之间如何通信及线程之间如何同步(这里的线程是指并发执行的活动实体).通信是指线程之间以何种机制来交换信息.在命令式编程中,线程之间的通信机制有两种:共享内存和消息传递. see:命令式编程.函数式编程 在共享内存的并发模型里,线程之间共享程序的公共状态,线程之间通过写-读内存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qa7rG3.html" rel="bookmark">【Todo】【转载】深入理解Java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考Infoq上的这篇文章:Link &lt;深入理解Java内存模型(一)--基础&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N1mJw3.html" rel="bookmark">深入理解Java内存模型（一）&mdash;&mdash;基础（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自程晓明的&quot;深入理解Java内存模型&quot;的博客 http://www.infoq.com/cn/articles/java-memory-model-1 并发编程模型的分类 在并发编程中,我们需要处理两个关键问题:线程之间如何通信及线程之间如何同步(这里的线程是指并发执行的活动实体).通信是指线程之间以何种机制来交换信息.在命令式编程中,线程之间的通信机制有两种:共享内存和消息传递. 在共享内存的并发模型里,线程之间共享程序的公共状态,线程之间通过写-读内存中的公共状态来隐式进行通信.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OkXLK3.html" rel="bookmark">深入理解java内存模型系列文章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://ifeve.com/java-memory-model-0/ 提纲 java线程之间的通信对程序员完全透明,内存可见性问题很容易困扰java程序员,本文试图揭开java内存模型神秘的面纱.本文大致分三部分:重排序与顺序一致性:三个同步原语(lock,volatile,final)的内存语义,重排序规则及在处理器中的实现:java内存模型的设计目标,及其与处理器内存模型和顺序一致性内存模型的关系. 原创文章,转载请注明: 转载自并发编程网 – ifeve.com本文链接地址: 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3w6JXV0.html" rel="bookmark">全面理解Java内存模型&lpar;JMM&rpar;及volatile关键字（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:全面理解Java内存模型(JMM)及volatile关键字 关联文章: 深入理解Java类型信息(Class对象)与反射机制 深入理解Java枚举类型(enum) 深入理解Java注解类型(@Annotation) 深入理解Java类加载器(ClassLoader) 深入理解Java并发之synchronized实现原理 Java并发编程-无锁CAS与Unsafe类及其并发包Atomic 深入理解Java内存模型(JMM)及volatile关键字 剖析基于并发AQS的重入锁(Reetr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MygQ7Y3.html" rel="bookmark">十二、深入理解Java内存模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				深入理解Java内存模型 [1]CPU和缓存的一致性 ? 我们应该都知道,计算机在执行程序的时候,每条指令都是在CPU中执行的,而执行的时候,又免不了要和数据打交道.而计算机上面的数据,是存放在主存当中的,也就是计算机的物理内存啦. ? 刚开始,还相安无事的,但是随着CPU技术的发展,CPU的执行速度越来越快.而由于内存的技术并没有太大的变化,所以从内存中读取和写入数据的过程和CPU的执行速度比起来差距就会越来越大,这就导致CPU每次操作内存都要耗费很多等待时间. ? 所以,人们想出来了一个好的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMGGR6M.html" rel="bookmark" class="title">关键字和继承</a>
					<div>
						1.关键字的使用 2.继承					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0a6lR3.html" rel="bookmark" class="title">一起学习kali linux</a>
					<div>
						因为加入了网络安全实验室需要学习kali linux,查了许多网上的教学材料和视频,粗略的看了看发现资源比较杂没用一个系统的学习过程导致学习效率较低,没有达到期望. 因此有了想写博客的想法,一来可以便 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4pGRy3.html" rel="bookmark" class="title">【mac】ansible安装及基础使用</a>
					<div>
						安装 环境释放 mac 10.12.5 #more /System/Library/CoreServices/SystemVersion.plist 安装命令 #ruby -e &quot;$(cur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQewb3.html" rel="bookmark" class="title">十三种常用的Web前端框架</a>
					<div>
						在做web开发的时候难免遇到一个问题,那就是,选择什么样的框架.下面把前端的框架简单的列一下. 1.flex Apache基金会今天发布了Flex 4.8版本,这是Adobe将Flex捐献给Apach ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRGGY3.html" rel="bookmark" class="title">linux下的文本处理命令sed&amp;amp&semi;awk&amp;amp&semi;grep</a>
					<div>
						Sedsed 是个精简的.非交互式的编辑器.他能执行和编辑vi和emacs相同的编辑任务.sed编辑器不提供交互使用方式:只能在命令行输入编辑命令.指定文件名,然后在屏幕上察看输出.sed编辑器没有破 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXwEz3.html" rel="bookmark" class="title">Laravel框架接入短信平台进行用户注册短信验证</a>
					<div>
						今天刚接触了一个短信接口平台,云通讯第三方短信提供服务商.http://www.yuntongxun.com/ 然后介绍一下怎么使用该短信平台来接入到自己的项目中. 首先你的去注册一个账号,然后根据提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWwgEaM.html" rel="bookmark" class="title">CSS制作照片墙</a>
					<div>
						资料来源:慕课网(点击这里) 课程结束后有两个效果: 效果一:CSS制作照片墙(点击这里) 效果二:旋转出现文字效果(点击这里) 实现代码: 1 &lt;!DOCTYPE html&gt; 2 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZa5y0.html" rel="bookmark" class="title">Gym 101334E dp</a>
					<div>
						分析: 这一题给出的遍历的点的序列,不是树的中序遍历,前序遍历,只要遇到一个节点就打印一个节点.关键点就在,这个序列的首字母和尾字母一定要相同,因为最终都会回到根节点,那么每一个子树也一样. 状态:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5XgyM.html" rel="bookmark" class="title">Jan 16 - Search for a Range&semi; Array&semi; Binary Search&semi;</a>
					<div>
						注意index不要出现out of bounds的情况: 代码: public class Solution { public int[] searchRange(int[] nums, int ta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOZ5w3.html" rel="bookmark" class="title">Ubuntu NFS 安装与配置</a>
					<div>
						Ubuntu NFS 安装与配置 一.NFS安装 $ sudo apt-get install nfs-kernel-server nfs-common portmap二.NFS配置    2.1 配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAzYnM.html" rel="bookmark" class="title">在Linux系统下用dd命令制作ISO镜像U盘启动盘</a>
					<div>
						http://os.51cto.com/art/201510/494762.htm 首先在 Linux 系统中打开终端,确认 U 盘路径: sudo fdisk -l 使用 dd 命令,格式如下: s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/498XBD3.html" rel="bookmark" class="title">博客园为自己首页添加背景音乐</a>
					<div>
						以网易云音乐为例: 选歌点击生成外链播放器会跳转到iframe找到下面的那段HTML代码,并复制那段代码 并将开头的iframe frameborder=&quot;no&quot;替换成 embed ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLqgA3.html" rel="bookmark" class="title">Uninstalling Cloudera Manager and CDH in SLES</a>
					<div>
						一.如果在安装过程中因为某些原因没有正常完成安装,你想重新继续安装. 执行: 1.删除文件和目录 rm -Rf /usr/share/cmf /var/lib/cloudera* /var/cache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7kZPM.html" rel="bookmark" class="title">zedboard--zynq使用自带外设IP让ARM PS访问FPGA（八） 转载</a>
					<div>
						文章来源 http://blog.chinaaet.com/detail/34609 熟悉了xps的操作,IP添加,总线连接设置,图形化方法检查(open graphical design view) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbeAvM.html" rel="bookmark" class="title">c&plus;&plus; autoptr 的初步实现</a>
					<div>
						1 template &lt;typename T&gt; 2 class AutoPtr{ 3 public: 4 explicit AutoPtr(T* ptr)//拒绝隐式转换 5 :ptr(p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7aNNM.html" rel="bookmark" class="title">机器学习中复杂概念的理解</a>
					<div>
						平均值和数学期望的区别? 均值(mean value)是针对既有的数值(简称母体)全部一个不漏个别都总加起来,做平均值(除以总母体个数),就叫做均值. 但是当这个数群(data group)的数量(n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YqzVO0.html" rel="bookmark" class="title">软件安装（linux）</a>
					<div>
						1.软件名称识别[abrt-addon-ccpp]-[2.1.11-19].[el7].[x86_64].rpm    ##rpm结尾的适用与redhat操作系统       ||        || ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38o2X10.html" rel="bookmark" class="title">POJ2503&lpar;hash&rpar;</a>
					<div>
						Babelfish Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 41263   Accepted: 17561 Descr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaaNN4.html" rel="bookmark" class="title">GIS基础软件及操作&lpar;一&rpar;</a>
					<div>
						原文  GIS基础软件及操作(一) 练习一.浏览地理数据 使用 ArcGIS浏览地理数据 第1步 启动 ArcMap 启动ArcMap.执行菜单命令:开始&gt;&gt;所有程序&gt;&gt; Ar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGnYDM.html" rel="bookmark" class="title">HDU&lowbar;3183&lowbar;A Magic Lamp&lpar;贪心&rpar;</a>
					<div>
						A Magic Lamp Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Tot ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
